'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _omit = require('lodash/omit');

var _omit2 = _interopRequireDefault(_omit);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Input = function (_React$PureComponent) {
  _inherits(Input, _React$PureComponent);

  function Input() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Input);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Input.__proto__ || Object.getPrototypeOf(Input)).call.apply(_ref, [this].concat(args))), _this), _this.click = function () {
      return _this.props.clickIcon ? _this.props.clickIcon() : null;
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Input, [{
    key: 'render',
    value: function render() {
      var props = (0, _omit2.default)(this.props, ['icon', 'clickIcon']);

      return _react2.default.createElement(
        'span',
        { className: 'holder' },
        _react2.default.createElement('input', props),
        this.props.icon && _react2.default.createElement(
          'span',
          { className: 'icon', onClick: this.click },
          this.props.icon
        ),
        _react2.default.createElement(
          'style',
          { jsx: true },
          '\n          .holder {\n            position: relative;\n            display: inline-table;\n            width: 100%;\n          }\n          .holder * {\n            box-sizing: border-box;\n          }\n          .icon {\n            position: absolute;\n            right: 10px;\n            top: 10px;\n            height: 22px;\n            width: 22px;\n          }\n          input {\n            background-color: rgb(246, 246, 246);\n            color: rgb(186, 186, 186);\n            border-radius: 12px;\n            padding: 0 15px;\n            box-shadow: 1px 2px 1px rgb(206, 206, 206) inset;\n            font-size: 14px;\n            outline: none;\n            border: none;\n            border: 2px solid transparent;\n            height: 40px;\n            width: 100%;\n            display: inline-block;\n          }\n          :focus {\n            color: rgb(186, 186, 186);\n            box-shadow: none;\n            border: 2px solid rgb(243, 214, 97);\n            background-color: rgb(255, 251, 234);\n            transition: all 0.55s;\n          }\n          ::-webkit-input-placeholder {\n            color: rgb(184, 184, 184);\n          }\n          ::-moz-placeholder {\n            color: rgb(184, 184, 184);\n          }\n          :-ms-input-placeholder {\n            color: rgb(184, 184, 184);\n          }\n          :-moz-placeholder {\n            color: rgb(184, 184, 184);\n          }\n        '
        )
      );
    }
  }]);

  return Input;
}(_react2.default.PureComponent);

Input.defaultProps = {
  icon: null,
  clickIcon: null
};

Input.propTypes = {
  type: _propTypes2.default.oneOf(['text', 'number', 'password']).isRequired,
  icon: _propTypes2.default.node,
  clickIcon: _propTypes2.default.func
};

exports.default = Input;